Public Class frmTriggers

    Private Sub DataGridView1_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grdTriggers.CellContentClick

    End Sub

    Private Sub TriggerDataBindingSource_CurrentChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub frmTriggers_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.grdTriggers.DataSource = Triggers
        Me.cboCondition.SelectedIndex = 0
    End Sub

    Private Sub Label5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label5.Click

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub cboFile_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFile.SelectedIndexChanged
        Dim cFile, dFile As String, Found As Boolean

        cFile = Me.cboFile.Items(Me.cboFile.SelectedIndex).ToString.ToUpper
        Me.cboScript.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dFile = IO.Path.GetFileName(sd.Filename).ToUpper
            If dFile = cFile Then
                '' Only add if not there already (multiple methods for same class)
                Found = False
                For Each s As String In cboScript.Items
                    If s = sd.ClassName Then
                        Found = True
                        Exit For
                    End If
                Next
                If Not Found Then Me.cboScript.Items.Add(sd.ClassName)
            End If
        Next
        If Me.cboScript.Items.Count > 0 Then Me.cboScript.SelectedIndex = 0
        Me.cboScript.Refresh()
    End Sub

    Private Sub cboScript_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboScript.SelectedIndexChanged
        Dim cClass, dClass As String

        cClass = Me.cboScript.Items(Me.cboScript.SelectedIndex).ToString.ToUpper
        Me.cboMethod.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dClass = IO.Path.GetFileName(sd.ClassName).ToUpper
            If dClass = cClass Then
                Me.cboMethod.Items.Add(sd.MethodName)
            End If
        Next
        If Me.cboMethod.Items.Count > 0 Then
            '' Determine Method Selection
            Me.cboMethod.SelectedIndex = 0
        End If
        Me.cboMethod.Refresh()
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Dim d As TriggerData

        d = New TriggerData(Me.txtDevice.Text, _
            Me.cboCondition.Items(Me.cboCondition.SelectedIndex), _
            Me.cboFile.Items(Me.cboFile.SelectedIndex), _
            Me.cboScript.Items(Me.cboScript.SelectedIndex), _
            Me.cboMethod.Items(Me.cboMethod.SelectedIndex), _
            Me.txtParms.Text)
        Triggers.Add(d)
        'Me.grdTriggers.DataSource = Nothing
        'TriggersBindingSource = New BindingSource
        'TriggersBindingSource.DataSource = Triggers
        'Me.grdTriggers.DataSource = TriggersBindingSource
        Me.grdTriggers.DataSource = Nothing
        Me.grdTriggers.DataSource = Triggers
        Me.grdTriggers.Refresh()


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        '' Delete Selected Trigger
        For Each selectedrow As DataGridViewRow In grdTriggers.SelectedRows
            '' Place data from deleted record into ADD fields
            '''' Device
            Me.txtDevice.Text = selectedrow.Cells("Device").Value.ToString
            '''' Condition
            For i As Integer = 0 To Me.cboCondition.Items.Count - 1
                If Me.cboCondition.Items(i).ToString = selectedrow.Cells("Condition").Value.ToString Then
                    Me.cboCondition.SelectedIndex = i
                    Exit For
                End If
            Next
            '''' File
            For i As Integer = 0 To Me.cboFile.Items.Count - 1
                If Me.cboFile.Items(i).ToString = selectedrow.Cells("File").Value.ToString Then
                    Me.cboFile.SelectedIndex = i
                    Exit For
                End If
            Next
            '''' Script
            For i As Integer = 0 To Me.cboScript.Items.Count - 1
                If Me.cboScript.Items(i).ToString = selectedrow.Cells("Script").Value.ToString Then
                    Me.cboScript.SelectedIndex = i
                    Exit For
                End If
            Next
            '''' Method
            For i As Integer = 0 To Me.cboMethod.Items.Count - 1
                If Me.cboMethod.Items(i).ToString = selectedrow.Cells("Method").Value.ToString Then
                    Me.cboMethod.SelectedIndex = i
                    Exit For
                End If
            Next
            '''' Parms
            Me.txtParms.Text = selectedrow.Cells("Parms").Value.ToString
            grdTriggers.Rows.Remove(selectedrow)
        Next
    End Sub
End Class